﻿using Api.Core.Code;
using Api.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace Api.Core.Controllers
{
    [Restricted]
    public class CDController : ApiController
    {

        //[Route("pippo")]
        //[HttpGet]
        public IEnumerable<CDItem> GetItems([FromUri] CDParams pars)
        {
            try
            {
                if (pars.MinValue > 100) throw new ArgumentOutOfRangeException();


                var temp = Enumerable.Range(1, 100).Where(p => p >= pars.MinValue)
                    .Select(p => new CDItem() { ID = p, Description = string.Format("Elem: {0}", p) });
                if (pars.Offset.HasValue) temp = temp.Skip(pars.Offset.Value);
                if (pars.Limit.HasValue) temp = temp.Take(pars.Limit.Value);
                return temp;
            }
            catch (ArgumentException)
            {
                throw new HttpResponseException(HttpStatusCode.BadRequest);
            }
            catch (Exception)
            {
                throw new HttpResponseException(HttpStatusCode.InternalServerError);
            }
           
        }

    }
}
